{$A+,B-,D-,E-,F-,G+,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+}
Program Uni_Fido;
Uses Dos,Crt;
Const Version='v1.00';
      ConfigPath      :String[12]='strchg.ctl'; {  䨣-䠩}

Type PControl=^TControl;
     TControl=record
        Name:String[64];
        Next:PControl;
              end;
     PMacro=^TMacro;
     TMacro=record
        Strng:String[64];
        Name:String[79];
        Value:String[64];
        Next:PMacro;
              end;
Var Control:PControl;
    Macro:PMacro;


Function GetWord(S:String; n:Word):String; forward; {頥 n- ᫮}
Procedure UpCaseString(var S:String); forward; {ॢ ப  UpCase}
Function IdString(S1,S2:String):Boolean; forward; {ࠢ  ப}

(***************************************************************************)
(* GetWord - 頥 n- ᫮  ப S ( UpCase)                 *)
(***************************************************************************)
Function GetWord(S:String; n:Word):String;
Var i,j,k:Integer;
Begin
 i:=0; j:=0; k:=0;                     {砫 ப, ࢮ ᫮}
 while (k<n) and (i<Length(S)) do      {  ⨣  ப  ᫮}
 begin
   i:=j+1;                             {  ।饥 ᫮}
   While (i<=Length(S)) and (S[i]=' ') do i:=i+1; { ஡ । ᫮}
   j:=i;                               {諨 砫 ᫮}
   While (j<=Length(S)) and (S[j]<>' ') do j:=j+1; {  ࢮ ஡}
   k:=k+1;                             {饥 ᫮}
 end;
 GetWord:=Copy(S,i,j-i);               {뤥塞 ᫮}
End;

(***************************************************************************)
(* UpCaseString - ८ࠧ ப S  孨 ॣ (/)         *)
(***************************************************************************)
Procedure UpCaseString(var S:String);
Var i:Integer;
    j:Byte;
Begin
 For i:=1 to Length(S) do
 begin
  j:=Ord(S[i]);
  If ((j>96) and (j<123)) or ((j>159) and (J<176)) then S[i]:=char(j-32) else
   if (j>223) and (j<240) then S[i]:=char(j-80);
 end;
End;

(***************************************************************************)
(* IdString - ࠢ  ப   ॣ                       *)
(***************************************************************************)
Function IdString(S1,S2:String):Boolean;
Begin
 UpCaseString(S1); UpCaseString(S2);   {८ࠧ㥬  孨 ॣ}
 IdString:=(S1=S2);                    {ࠢ ப}
End;

(***************************************************************************)
(* NewControl -  䠩,      Control    *)
(***************************************************************************)
Procedure NewControl(S:String);
Var P:PControl;
Begin
 New(P);
 P^.Name:=S;
 P^.Next:=Control;
 Control:=P;
End;

(***************************************************************************)
(* NewMacro -      Macro                      *)
(***************************************************************************)
Procedure NewMacro(Id,S:String);
Var P:PMacro;
    C:String;
Begin
 New(P);
 P^.Strng:=Id;
 C:=GetWord(S,3);
 P^.Name:=Copy(S,Pos(C,S),length(S)-Pos(C,S)+1);
 P^.Value:='';
 P^.Next:=Macro;
 Macro:=P;
End;

(***************************************************************************)
(* ReadConfig - ⠥ 䨣-䠩, । ConfigPath                *)
(***************************************************************************)
Procedure ReadConfigFile(ConfigPath:String);
Var F:Text;
    S,Id,St:String;
    i:Integer;
Begin
 Assign(F,ConfigPath); Reset(F);       {஥ 䠩 䨣}
 If IOResult<>0 then                   {᫨ 䨣  , 뤠 ।०}
     begin Writeln('- Can''t find config file '+ConfigPath+char(13)); halt(1) end
 else begin
 While not Eof(F) do                   { 䠩  稫}
 begin
  Readln(F,S);                         {㧨 }
  If (S[1]<>';') and (S[1]<>'.') and (S<>'') then { ਩      }
  begin
   Id:=GetWord(S,1); St:=GetWord(S,2); {ਬ   Id  St}
   If IdString(Id,'Control')       then NewControl(St)       else
   If IdString(Id,'Macro')         then NewMacro(St,S)       else
     ;
  end;
 end;
 Close(F); end;                         {஥ 䨣}
End;

(***************************************************************************)
(* ChangeMacro -     ப S  ப C   V      *)
(***************************************************************************)
Procedure ChangeMacro(var S:String; C,V:String);
Var l:Integer;
    S2:String;
Begin
 S2:=S;
 UpCaseString(S2); UpCaseString(C);
 l:=Pos(C,S2);
 if l<>0 then
   begin
      Delete(S,l,Length(C));
      Insert(V,S,l);
   end;
End;

(***************************************************************************)
(* ChangeMacros -   ப                              *)
(***************************************************************************)
Procedure ChangeMacros(var S:String);
Var P:PMacro;
Begin
  P:=Macro;
  While P<>Nil do
  begin
    ChangeMacro(S,P^.Strng,P^.Value);
    P:=P^.Next;
  end;
End;

(***************************************************************************)
(* ReadProperties - ⠥                       *)
(***************************************************************************)
Procedure ReadProperties;
Var P:PMacro;
Begin
  P:=Macro;
  While P<>Nil do
  begin
    TextColor(15);
    Writeln(P^.Name);
    TextColor(7);
    Readln(P^.Value);
    P:=P^.Next;
  end;
End;

(***************************************************************************)
(* CorrectControls - ࠢ 䨣-䠩                               *)
(***************************************************************************)
Procedure CorrectControls;
Var FO,FN:Text;
    P:PControl;
    S:String;
Begin
 P:=Control;
 TextColor(Red+8);
 While P<>Nil do
 begin
  Assign(FO,P^.Name);
  Rename(FO,'current.$$$');
  If IOResult<>0 then writeln('Not exist: '+P^.Name) else
  begin
    Reset(FO);
    Assign(FN,P^.Name); Rewrite(FN);
    while not Eof(FO) do
    begin
      Readln(FO,S);
      ChangeMacros(S);
      Writeln(FN,S);
    end;
    Close(FO); Erase(FO);
    Close(FN);
  end;
  P:=P^.Next;
 end;
 TextColor(7);
End;





(***************************************************************************)
(*                             ᭮ ண                              *)
(***************************************************************************)
Var S:String;
    P:PMacro;
Begin
 TextColor(14);
 Writeln(char(13),'String Changer '+Version+' Copyright (c) 1996 Dmitri Panev 2:5003/10.26@fidonet');
 ReadConfigFile(ConfigPath);           {⠥ 䨣-䠩}
 ReadProperties;                       { ࠬ ⠭樨}
 CorrectControls;                      {ࠢ塞 䠩}
End.
